---
title: PaymentResponse
slug: Web/API/PaymentResponse
tags:
  - API
  - Experimental
  - Interface
  - Payment Request
  - PaymentResponse
  - Reference
  - Secure context
---
<p>{{securecontext_header}}{{APIRef("Payment Request API")}}</p>

<p>The <strong><code>PaymentResponse</code></strong> interface of the <a href="/en-US/docs/Web/API/Payment_Request_API">Payment Request API</a> is returned after a user selects a payment method and approves a payment request.</p>

<h2 id="Properties">Properties</h2>

<dl>
	<dt>{{domxref('PaymentResponse.details')}} {{readonlyinline}} {{securecontext_inline}}</dt>
	<dd>Returns a JSON-serializable object that provides a payment method specific message used by the merchant to process the transaction and determine successful fund transfer. The contents of the object depend on the payment method being used; for example, if the Basic Card payment method is used, this object must conform to the structure defined in the {{domxref("BasicCardResponse")}} dictionary.</dd>
	<dt>{{domxref('PaymentResponse.methodName')}} {{readonlyinline}} {{securecontext_inline}}</dt>
	<dd>Returns the payment method identifier for the payment method that the user selected, for example, Visa, Mastercard, Paypal, etc.. </dd>
	<dt>{{domxref('PaymentResponse.payerEmail')}} {{readonlyinline}} {{securecontext_inline}}</dt>
	<dd>Returns the email address supplied by the user. This option is only present when the <code>requestPayerEmail</code> option is set to <code>true</code> in the <code>options</code> parameter of the {{domxref('PaymentRequest.PaymentRequest','PaymentRequest()')}} constructor.</dd>
	<dt>{{domxref('PaymentResponse.payerName')}} {{readonlyinline}} {{securecontext_inline}}</dt>
	<dd>Returns the name supplied by the user. This option is only present when the <code>requestPayerName</code> option is set to true in the <code>options</code> parameter of the {{domxref('PaymentRequest.PaymentRequest','PaymentRequest()')}} constructor.</dd>
	<dt>{{domxref('PaymentResponse.payerPhone')}} {{readonlyinline}} {{securecontext_inline}}</dt>
	<dd>Returns the phone number supplied by the user. This option is only present when the <code>requestPayerPhone</code> option is set to <code>true</code> in the <code>options</code> parameter of the {{domxref('PaymentRequest.PaymentRequest','PaymentRequest()')}} constructor.</dd>
	<dt>{{domxref('PaymentResponse.requestId')}} {{readonlyinline}} {{securecontext_inline}}</dt>
	<dd>Returns the identifier of the {{domxref('PaymentRequest')}} that produced the current response. This is the same value supplied in the {{domxref('PaymentRequest.PaymentRequest','PaymentRequest()')}} constructor by <code>details.id</code>.</dd>
	<dt>{{domxref('PaymentResponse.shippingAddress')}} {{readonlyinline}} {{securecontext_inline}}</dt>
	<dd>Returns the shipping Address supplied by the user. This option is only present when the <code>requestShipping</code> option is set to <code>true</code> in the <code>options</code> parameter of the {{domxref('PaymentRequest.PaymentRequest','PaymentRequest()')}} constructor.</dd>
	<dt>{{domxref('PaymentResponse.shippingOption')}} {{readonlyinline}} {{securecontext_inline}}</dt>
	<dd>Returns the ID attribute of the shipping option selected by the user. This option is only present when the <code>requestShipping</code> option is set to <code>true</code> in the <code>options</code> parameter of the {{domxref('PaymentRequest.PaymentRequest','PaymentRequest()')}} constructor.</dd>
</dl>

<h2 id="Methods">Methods</h2>

<dl>
	<dt>{{domxref('PaymentResponse.retry()')}} {{securecontext_inline}}</dt>
	<dd>If something is wrong with the payment response's data (and there is a recoverable error), this method allows a merchant to request that the user retry the payment. The method takes an object as argument, which is used to signal to the user exactly what is wrong with the payment response so they can try to correct any issues.</dd>
	<dt>{{domxref('PaymentResponse.complete()')}} {{securecontext_inline}}</dt>
	<dd>Notifies the user agent that the user interaction is over. This causes any remaining user interface to be closed. This method should only be called after the Promise returned by the {{domxref('PaymentRequest.show()')}} method.</dd>
</dl>

<h2 id="Events">Events</h2>

<p>Listen to this event using <code><a href="/en-US/docs/Web/API/EventTarget/addEventListener">addEventListener()</a></code> or by assigning an event listener to the <code>on<em>eventname</em></code> property of this interface.</p>

<dl>
	<dt><code><a href="/en-US/docs/Web/API/PaymentResponse/payerdetailchange_event">payerdetailchange</a></code><a href="/en-US/docs/Web/API/PaymentResponse/payerdetail_event"> </a>{{securecontext_inline}}</dt>
	<dd>Fired during a retry when the user makes changes to their personal information while filling out a payment request form. Allows the developer to revalidate any requested user data (e.g., the phone number or the email address) if it changes.<br>
	Also available via the <code><a href="/en-US/docs/Web/API/PaymentResponse/onpayerdetailchange">onpayerdetailchange</a></code> property.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
	<tbody>
		<tr>
			<th scope="col">Specification</th>
			<th scope="col">Status</th>
			<th scope="col">Comment</th>
		</tr>
		<tr>
			<td>{{SpecName('Payment','#paymentresponse-interface','PaymentResponse')}}</td>
			<td>{{Spec2('Payment')}}</td>
			<td>Initial definition.</td>
		</tr>
	</tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.PaymentResponse")}}</p>
</div>
